
QGIS Application - Bug report #13099

[regression] nodetool cannot remove parts and rings or full geometries by removing all vertices

2015-07-09 07:14 AM - Jürgen Fischer

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Digitising

Affected QGIS version:2.10.0 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 21165

Description

The old geometry implementation allowed to remove vertices even if that would produce invalid geometry (commit:c686c4f).  This was

meant to allow interim steps to fix already broken geometry in the nodetool (eg. remove invalid rings, that the remove ring tool doesn't

find).

The commit even included a test that used to verify this worked.  Unfortunately it was also changed (commit:68fe5f5; "line

967":#68fe5f5#diff-fe3aa1328ee04f0eb00a1b1d59c0ea71L967).

Looking at the changed tests also noticed that the behavior of QgsGeometry::insertVertex() and QgsGeometry::deleteVertex() on

MultiPoint geometries apparently changed as that test was substantially trimmed as well ("line

757":#68fe5f5#diff-fe3aa1328ee04f0eb00a1b1d59c0ea71L757; introduced in commit:cb5c4e9).

Related issues:

Related to QGIS Application - Bug report # 13258: delete part cannot make fea... Closed 2015-08-24

Related to QGIS Application - Bug report # 13276: node tool regressions and i... Closed 2015-08-27

Related to QGIS Application - Bug report # 13661: Node tool should not allow ... Closed 2015-10-23

Associated revisions

Revision fe5085e8 - 2015-09-09 07:17 AM - Nyall Dawson

Fix up missing geometry tests (refs #13099)

Revision acd8f26a - 2015-09-09 08:51 AM - Nyall Dawson

Fix removing whole ring by progressively deleting nodes (fix #13099)

Revision 8640c130 - 2015-09-11 04:57 PM - Marco Hugentobler

Merge pull request #2298 from nyalldawson/fix_13099

Fix #13099 - removal of geometries using node tool

History

#1 - 2015-07-15 11:11 PM - Nyall Dawson

PR #2212 (https://github.com/qgis/QGIS/pull/2212) brings back the missing tests, but doesn't fix the underlying issues...
https://github.com/qgis/QGIS/pull/2212


#2 - 2015-07-31 01:19 AM - Giovanni Manghi

- Priority changed from Normal to Severe/Regression

- Category set to Digitising

#3 - 2015-09-07 02:44 AM - Marco Hugentobler

It is debatable wether a vertex tool should remove not only vertices, but also features or rings. There are other tools for that (therefore the changed tests). I

however see jefs argument to temporarily fix broken geometries, so I'm trying to bring that functionality back.

#4 - 2015-09-07 02:51 AM - Jürgen Fischer

Marco Hugentobler wrote:

It is debatable wether a vertex tool should remove not only vertices, but also features or rings. There are other tools for that (therefore the changed

tests). I however see jefs argument to temporarily fix broken geometries, so I'm trying to bring that functionality back.

BTW the other tools rely on GEOS to find the geometries/rings/parts - which usually doesn't work if geometries are broken.  So the geometries must be

"fixed" first in the nodetool and then removed using the other tools - hence that was added to the nodetool directly.

#5 - 2015-09-10 02:56 AM - Nyall Dawson

It is debatable wether a vertex tool should remove not only vertices, but also features or rings. There are other tools for that (therefore the changed

tests). I however see jefs argument to temporarily fix broken geometries, so I'm trying to bring that functionality back.

Looking at how the new geometry classes function it seems like they are all hard-coded to prevent creation of invalid geometries (and modifications like

these which result in invalid geometries). But I'm not sure about this approach... wouldn't a better way be to allow creation and modifications which result in

invalid geometries in QgsGeometry, but block (or fix) their creation in the map tools? The reality is that invalid geometries are prevalent throughout

geospatial data, and QGIS still needs to be able to read and work with these geometries.

#6 - 2015-09-11 07:57 AM - Marco Hugentobler

- Status changed from Open to Closed

Fixed in changeset commit:"8640c1300265a81bf5122d4510e01668e38f700f".
